<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");

DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	DateFormatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~import-inca.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>

#importcheck td 
{
	padding-top: 0.25em;
	padding-bottom: 0.25em;
}

#importcheck td.subprompt
{
	text-align: left;
	padding-left: 4em;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Update INCA data annotations" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select INCA file to import</div>
		<div class="step-content">
			
			<table class="step-form">
			<tr>
				<td class="prompt">INCA export date</td>
				<td class="input">
					<input type="text" name="exportDate" id="exportDate"
						value="<%=dateFormat.format(new Date()) %>"
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="importFile"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="exportDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="exportDate"
							data-date-format="yyyyMMdd"
							data-title="INCA export date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="exportDate.status"></td>
				<td class="help">
					<span id="exportDate.message" class="message" style="display: none;"></span>
					(YYYYMMDD or MMDD) The INCA export date annotation for cases
					found in the selected file will be updated to this value.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">INCA file</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input type="file" name="importfile" id="importfile" class="required" style="width: 95%;" accept=".csv,.tsv">
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="importfile.status"></td>
				<td class="help"><span id="importfile.message" class="message"></span>
					Select INCA file to be used for INCA import. The file should be a text file in tab-separated format, where the first line contains column names.
				</td>
			</tr>
			</table>
		</div>
	</div>

	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">INCA file check</div>
		<div class="step-content">


			<table class="step-form" id="importcheck">
			<tbody>
				<tr>
					<td class="prompt">File</td>
					<td class="input" id="filename"></td>
					<td class="status" id="filename.status"></td>
					<td class="help"></td>
				</tr>
				<tr>
					<td class="prompt">Is follow-up file</td>
					<td class="input" id="isFollowUp"></td>
					<td class="status" id="isFollowUp.status"></td>
					<td class="help">
					</td>
				</tr>
				<tr>
					<td class="prompt">Header columns</td>
					<td class="input" id="headerCount"></td>
					<td class="status" id="headerCount.status"></td>
					<td class="help"></td>
				</tr>
			</tbody>
			
			<tbody class="info-section">
				<tr>
					<td class="prompt">Required but missing</td>
					<td class="info" id="headerMissing"></td>
					<td class="status" id="headerMissing.status"></td>
					<td class="help"><span id="headerMissing.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Duplicates</td>
					<td class="info" id="headerDuplicates"></td>
					<td class="status" id="headerDuplicates.status"></td>
					<td class="help"><span id="headerDuplicates.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Unknown</td>
					<td class="info" id="headerUnknown"></td>
					<td class="status" id="headerUnknown.status"></td>
					<td class="help"><span id="headerUnknown.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Mapped INCA annotations</td>
					<td class="info" id="headerMapped"></td>
					<td class="status" id="headerMapped.status"></td>
					<td class="help"><span id="headerMapped.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Unmapped INCA annotations</td>
					<td class="info" id="headerUnmapped"></td>
					<td class="status" id="headerUnmapped.status"></td>
					<td class="help"><span id="headerUnmapped.message"></span></td>
				</tr>
			</tbody>
			
			<tbody>
				<tr>
					<td class="prompt">Data lines</td>
					<td class="input" id="lineCount"></td>
					<td class="status" id="lineCount.status"></td>
					<td class="help"><span id="lineCount.message"></span></td>
				</tr>
			</tbody>
			<tbody class="info-section">
				<tr>
					<td class="prompt">Lines that can be imported</td>
					<td class="input" id="importLineCount"></td>
					<td class="status" id="importLineCount.status"></td>
					<td class="help"><span id="importLineCount.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Excluded lines</td>
					<td class="info" id="totalExcluded"></td>
					<td class="status" id="totalExcluded.status"></td>
					<td class="help"><span id="totalExcluded.message"></span></td>
				</tr>
				<tr id="tooManyColumns.row">
					<td class="subprompt">- too many columns</td>
					<td class="info" id="tooManyColumns"></td>
					<td class="status" id="tooManyColumns.status"></td>
					<td class="help"><span id="tooManyColumns.message"></span></td>
				</tr>
				<tr id="tooFewColumns.row">
					<td class="subprompt">- too few columns</td>
					<td class="info" id="tooFewColumns"></td>
					<td class="status" id="tooFewColumns.status"></td>
					<td class="help"><span id="tooFewColumns.message"></span></td>
				</tr>
				<tr id="missingPersonalNo.row">
					<td class="subprompt">- missing personal number</td>
					<td class="info" id="missingPersonalNo"></td>
					<td class="status" id="missingPersonalNo.status"></td>
					<td class="help"><span id="missingPersonalNo.message"></span></td>
				</tr>
				<tr id="missingLaterality.row">
					<td class="subprompt">- missing or invalid laterality</td>
					<td class="info" id="missingLaterality"></td>
					<td class="status" id="missingLaterality.status"></td>
					<td class="help"><span id="missingLaterality.message"></span></td>
				</tr>
				<tr id="duplicateLaterality.row">
					<td class="subprompt">- duplicate laterality</td>
					<td class="info" id="duplicateLaterality"></td>
					<td class="status" id="duplicateLaterality.status"></td>
					<td class="help"><span id="duplicateLaterality.message"></span></td>
				</tr>
				<tr id="missingFollowUpDate.row">
					<td class="subprompt">- missing follow up date</td>
					<td class="info" id="missingFollowUpDate"></td>
					<td class="status" id="missingFollowUpDate.status"></td>
					<td class="help"><span id="missingFollowUpDate.message"></span></td>
				</tr>
				<tr id="duplicateFollowUp.row">
					<td class="subprompt">- duplicate follow up</td>
					<td class="info" id="duplicateFollowUp"></td>
					<td class="status" id="duplicateFollowUp.status"></td>
					<td class="help"><span id="duplicateFollowUp.message"></span></td>
				</tr>
				<tr id="invalidDataValue.row">
					<td class="subprompt">- invalid data value</td>
					<td class="info" id="invalidDataValue"></td>
					<td class="status" id="invalidDataValue.status"></td>
					<td class="help"><span id="invalidDataValue.message"></span></td>
				</tr>
				<tr id="patientNotFound.row">
					<td class="subprompt">- patient not found</td>
					<td class="info" id="patientNotFound"></td>
					<td class="status" id="patientNotFound.status"></td>
					<td class="help"><span id="patientNotFound.message"></span></td>
				</tr>
				<tr id="caseNotFound.row">
					<td class="subprompt">- case not found</td>
					<td class="info" id="caseNotFound"></td>
					<td class="status" id="caseNotFound.status"></td>
					<td class="help"><span id="caseNotFound.message"></span></td>
				</tr>
			</tbody>
		</table>
		</div>
	</div>

	<div id="wizard-status"></div>
	<div id="wizard-progress"></div>

	<div id="reportfiles" style="margin-left: 2em; margin-top: 0.5em;">
		<base:icon id="downloadreportfile" style="display: none;" 
			image="<%=home+"/images/download.png"%>"
			data-report-type="import"
			>Download report file</base:icon>
		<base:icon id="downloadoutputfile" style="display: none;" 
			image="<%=home+"/images/download.png"%>"
			data-report-type="import_output_csv"
			>Download output CSV file</base:icon>
	</div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="simplecheck" title="Simple file check" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="fullcheck" title="Full file check" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goimport" title="Import" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	<div id="explainFileCheck" class="messagecontainer note" style="margin-left: 2em; padding: 0.5em;width: 55em;">
		<ul>
		<li style="margin-bottom: 0.25em;"><b>Simple file check</b>: Checks that the INCA data file is well formed, 
			that required information is present and that data values are valid. This check is typically very quick and 
			should only take a few seconds to complete.
		<li><b>Full file check</b>: Also checks that the data can be mapped to patient and case information in 
			the database. This check may require several minutes to complete.
		</ul>
	</div>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>